<template>
  <div>
    <gz-report-selector ref="reportSelector"></gz-report-selector>
    <div v-if="formState.ready">
      <gz-error :error-box-message="formState.errorBoxMessage"></gz-error>
      <v-form ref="form">
        <v-tabs v-model="tab" mobile-breakpoint="100">
          <v-tab>{{ $ay.t("Unit") }}</v-tab>
          <v-tab>{{ $ay.t("Address") }}</v-tab>
          <v-tab>{{ $ay.t("UnitOverrideWarranty") }}</v-tab>
          <v-tabs-items v-model="tab">
            <v-tab-item class="mt-4 ml-2">
              <v-row dense>
                <v-col cols="12" sm="6" lg="4" xl="3">
                  <v-text-field
                    ref="serial"
                    v-model="obj.serial"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitSerial')"
                    :rules="[form().required(this, 'serial')]"
                    :error-messages="form().serverErrors(this, 'serial')"
                    data-cy="serial"
                    @input="fieldValueChanged('serial')"
                  ></v-text-field>
                </v-col>

                <v-col cols="12" sm="6" lg="4" xl="3">
                  <gz-pick-list
                    ref="customerId"
                    v-model="obj.customerId"
                    :aya-type="ayaTypes().Customer"
                    show-edit-icon
                    :readonly="formState.readOnly"
                    :label="$ay.t('Customer')"
                    data-cy="customerId"
                    :error-messages="form().serverErrors(this, 'customerId')"
                    @input="fieldValueChanged('customerId')"
                  ></gz-pick-list>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Description')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="description"
                    v-model="obj.description"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitDescription')"
                    data-cy="description"
                    :error-messages="form().serverErrors(this, 'description')"
                    @input="fieldValueChanged('description')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'UnitModelId')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-pick-list
                    ref="unitModelId"
                    v-model="obj.unitModelId"
                    :aya-type="ayaTypes().UnitModel"
                    show-edit-icon
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitModel')"
                    data-cy="unitModelId"
                    :error-messages="form().serverErrors(this, 'unitModelId')"
                    @input="fieldValueChanged('unitModelId')"
                  ></gz-pick-list>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'ReplacedByUnitId')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-pick-list
                    ref="replacedByUnitId"
                    v-model="obj.replacedByUnitId"
                    :aya-type="ayaTypes().Unit"
                    show-edit-icon
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitReplacedByUnitID')"
                    data-cy="replacedByUnitId"
                    :error-messages="
                      form().serverErrors(this, 'replacedByUnitId')
                    "
                    @input="fieldValueChanged('replacedByUnitId')"
                  ></gz-pick-list>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'ParentUnitId')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-pick-list
                    ref="parentUnitId"
                    v-model="obj.parentUnitId"
                    :aya-type="ayaTypes().Unit"
                    show-edit-icon
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitParentUnitID')"
                    data-cy="parentUnitId"
                    :error-messages="form().serverErrors(this, 'parentUnitId')"
                    @input="fieldValueChanged('parentUnitId')"
                  ></gz-pick-list>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'ContractId')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-pick-list
                    ref="contractId"
                    v-model="obj.contractId"
                    :aya-type="ayaTypes().Contract"
                    show-edit-icon
                    :readonly="formState.readOnly"
                    :label="$ay.t('Contract')"
                    data-cy="contractId"
                    :error-messages="form().serverErrors(this, 'contractId')"
                    @input="fieldValueChanged('contractId')"
                  ></gz-pick-list>
                </v-col>

                <v-col
                  v-if="
                    form().showMe(this, 'ContractExpires') && obj.contractId
                  "
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-date-time-picker
                    ref="contractExpires"
                    v-model="obj.contractExpires"
                    :label="$ay.t('ContractExpires')"
                    :readonly="formState.readOnly"
                    data-cy="contractExpires"
                    :error-messages="
                      form().serverErrors(this, 'contractExpires')
                    "
                    @input="fieldValueChanged('contractExpires')"
                  ></gz-date-time-picker>
                </v-col>

                <!-- <v-col
                  v-if="form().showMe(this, 'UsesBanking')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-checkbox
                    v-model="obj.usesBanking"
                    :readonly="formState.readOnly"
                    :label="$ay.t('UsesBanking')"
                    ref="usesBanking"
                    data-cy="usesBanking"
                    :error-messages="form().serverErrors(this, 'usesBanking')"
                    @change="fieldValueChanged('usesBanking')"
                  >
                    <template v-slot:append v-if="canOpenServiceBank()">
                      <v-btn
                        outlined
                        small
                        color="primary"
                        @click="openServiceBank"
                        class="ml-12"
                      >
                        <v-icon>$ayiCarBattery</v-icon></v-btn
                      >
                    </template>
                  </v-checkbox>
                </v-col> -->

                <v-col
                  v-if="form().showMe(this, 'Metered')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-checkbox
                    ref="metered"
                    v-model="obj.metered"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitMetered')"
                    data-cy="metered"
                    :error-messages="form().serverErrors(this, 'metered')"
                    @change="fieldValueChanged('metered')"
                  >
                    <template v-if="canOpenMeter()" v-slot:append>
                      <v-btn outlined small color="primary" @click="openMeter">
                        <v-icon>$ayiWeight</v-icon></v-btn
                      >
                    </template>
                  </v-checkbox>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'BoughtHere')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-checkbox
                    ref="boughtHere"
                    v-model="obj.boughtHere"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitBoughtHere')"
                    data-cy="boughtHere"
                    :error-messages="form().serverErrors(this, 'boughtHere')"
                    @change="fieldValueChanged('boughtHere')"
                  ></v-checkbox>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'PurchasedFromVendorId')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-pick-list
                    ref="purchasedFromVendorId"
                    v-model="obj.purchasedFromVendorId"
                    :aya-type="ayaTypes().Vendor"
                    show-edit-icon
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitPurchaseFromID')"
                    data-cy="purchasedFromVendorId"
                    :error-messages="
                      form().serverErrors(this, 'purchasedFromVendorId')
                    "
                    @input="fieldValueChanged('purchasedFromVendorId')"
                  ></gz-pick-list>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'PurchasedDate')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-date-time-picker
                    ref="purchasedDate"
                    v-model="obj.purchasedDate"
                    :label="$ay.t('UnitPurchasedDate')"
                    :readonly="formState.readOnly"
                    data-cy="purchasedDate"
                    :error-messages="form().serverErrors(this, 'purchasedDate')"
                    @input="fieldValueChanged('purchasedDate')"
                  ></gz-date-time-picker>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Receipt')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="receipt"
                    v-model="obj.receipt"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitReceipt')"
                    data-cy="receipt"
                    :error-messages="form().serverErrors(this, 'receipt')"
                    @input="fieldValueChanged('receipt')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Text1')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="text1"
                    v-model="obj.text1"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitText1')"
                    :error-messages="form().serverErrors(this, 'text1')"
                    data-cy="text1"
                    @input="fieldValueChanged('text1')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Text2')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="text2"
                    v-model="obj.text2"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitText2')"
                    :error-messages="form().serverErrors(this, 'text2')"
                    data-cy="text2"
                    @input="fieldValueChanged('text2')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Text3')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="text3"
                    v-model="obj.text3"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitText3')"
                    :error-messages="form().serverErrors(this, 'text3')"
                    data-cy="text3"
                    @input="fieldValueChanged('text3')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Text4')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="text4"
                    v-model="obj.text4"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitText4')"
                    :error-messages="form().serverErrors(this, 'text4')"
                    data-cy="text4"
                    @input="fieldValueChanged('text4')"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" lg="4" xl="3">
                  <v-checkbox
                    ref="active"
                    v-model="obj.active"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('Active')"
                    data-cy="active"
                    :error-messages="form().serverErrors(this, 'active')"
                    @change="fieldValueChanged('active')"
                  ></v-checkbox>
                </v-col>
                <!-- --------------------------------- -->
                <v-col v-if="form().showMe(this, 'Notes')" cols="12">
                  <v-textarea
                    ref="notes"
                    v-model="obj.notes"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitNotes')"
                    :error-messages="form().serverErrors(this, 'notes')"
                    data-cy="notes"
                    auto-grow
                    @input="fieldValueChanged('notes')"
                  ></v-textarea>
                </v-col>

                <v-col v-if="form().showMe(this, 'Tags')" cols="12">
                  <gz-tag-picker
                    ref="tags"
                    v-model="obj.tags"
                    :readonly="formState.readOnly"
                    data-cy="tags"
                    :error-messages="form().serverErrors(this, 'tags')"
                    @input="fieldValueChanged('tags')"
                  ></gz-tag-picker>
                </v-col>

                <v-col cols="12">
                  <gz-custom-fields
                    ref="customFields"
                    v-model="obj.customFields"
                    :form-key="formCustomTemplateKey"
                    :readonly="formState.readOnly"
                    :parent-v-m="this"
                    data-cy="customFields"
                    :error-messages="form().serverErrors(this, 'customFields')"
                    @input="fieldValueChanged('customFields')"
                  ></gz-custom-fields>
                </v-col>

                <v-col v-if="form().showMe(this, 'Wiki')" cols="12">
                  <gz-wiki
                    ref="wiki"
                    v-model="obj.wiki"
                    :aya-type="ayaType"
                    :aya-id="obj.id"
                    :readonly="formState.readOnly"
                    @input="fieldValueChanged('wiki')"
                  ></gz-wiki
                ></v-col>

                <v-col
                  v-if="form().showMe(this, 'Attachments') && obj.id"
                  cols="12"
                >
                  <gz-attachments
                    :readonly="formState.readOnly"
                    :aya-type="ayaType"
                    :aya-id="obj.id"
                  ></gz-attachments
                ></v-col>
              </v-row>
            </v-tab-item>
            <!-- 
                
                ################################# ADDRESS TAB ######################### 
            
            -->
            <v-tab-item class="mt-4 ml-2">
              <v-row dense>
                <v-col cols="12">
                  <v-checkbox
                    ref="unitHasOwnAddress"
                    v-model="obj.unitHasOwnAddress"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitUnitHasOwnAddress')"
                    data-cy="unitHasOwnAddress"
                    :error-messages="
                      form().serverErrors(this, 'unitHasOwnAddress')
                    "
                    @change="fieldValueChanged('unitHasOwnAddress')"
                  ></v-checkbox>
                  <v-col v-if="obj.unitHasOwnAddress" cols="12">
                    <v-menu v-if="rights.change" offset-y>
                      <template v-slot:activator="{ on, attrs }">
                        <span class="text-h6">
                          {{ $ay.t("AddressTypePhysical") }}</span
                        ><v-btn icon v-bind="attrs" v-on="on">
                          <v-icon small>$ayiEllipsisV</v-icon>
                        </v-btn>
                      </template>
                      <v-list>
                        <v-list-item @click="AddressCopyPhysicalToClipBoard()">
                          <v-list-item-icon>
                            <v-icon>$ayiCopy</v-icon>
                          </v-list-item-icon>
                          <v-list-item-title>{{
                            $ay.t("CopyToClipboard")
                          }}</v-list-item-title>
                        </v-list-item>

                        <v-list-item @click="GeoCapture">
                          <v-list-item-icon>
                            <v-icon>$ayiMapMarker</v-icon>
                          </v-list-item-icon>
                          <v-list-item-title>{{
                            $ay.t("GeoCapture")
                          }}</v-list-item-title>
                        </v-list-item>
                      </v-list>
                    </v-menu>
                    <span v-else class="text-h6">
                      {{ $ay.t("AddressTypePhysical") }}</span
                    >
                  </v-col>
                </v-col>
                <v-col
                  v-if="form().showMe(this, 'Address') && obj.unitHasOwnAddress"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="address"
                    v-model="obj.address"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressDeliveryAddress')"
                    data-cy="address"
                    :error-messages="form().serverErrors(this, 'address')"
                    @input="fieldValueChanged('address')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'City') && obj.unitHasOwnAddress"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="city"
                    v-model="obj.city"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressCity')"
                    data-cy="city"
                    :error-messages="form().serverErrors(this, 'city')"
                    @input="fieldValueChanged('city')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Region') && obj.unitHasOwnAddress"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="region"
                    v-model="obj.region"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressStateProv')"
                    data-cy="region"
                    :error-messages="form().serverErrors(this, 'region')"
                    @input="fieldValueChanged('region')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Country') && obj.unitHasOwnAddress"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="country"
                    v-model="obj.country"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressCountry')"
                    data-cy="country"
                    :error-messages="form().serverErrors(this, 'country')"
                    @input="fieldValueChanged('country')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'AddressPostal')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="addressPostal"
                    v-model="obj.addressPostal"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressPostal')"
                    data-cy="addressPostal"
                    :error-messages="form().serverErrors(this, 'addressPostal')"
                    @input="fieldValueChanged('addressPostal')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Latitude')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-decimal
                    ref="latitude"
                    v-model="obj.latitude"
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressLatitude')"
                    data-cy="latitude"
                    :rules="[form().decimalValid(this, 'latitude')]"
                    :error-messages="form().serverErrors(this, 'latitude')"
                    :precision="6"
                    @input="fieldValueChanged('latitude')"
                  ></gz-decimal>
                </v-col>

                <v-col
                  v-if="form().showMe(this, 'Longitude')"
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <gz-decimal
                    ref="longitude"
                    v-model="obj.longitude"
                    :readonly="formState.readOnly"
                    :label="$ay.t('AddressLongitude')"
                    data-cy="longitude"
                    :rules="[form().decimalValid(this, 'longitude')]"
                    :error-messages="form().serverErrors(this, 'longitude')"
                    :precision="6"
                    @input="fieldValueChanged('longitude')"
                  ></gz-decimal>
                </v-col>
              </v-row>
            </v-tab-item>
            <!-- 
                
                ################################# WARRANTY TAB ######################### 
            
            -->
            <v-tab-item class="mt-4 ml-2">
              <v-row dense>
                <v-col cols="12" sm="6" lg="4" xl="3">
                  <v-checkbox
                    ref="overrideModelWarranty"
                    v-model="obj.overrideModelWarranty"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitOverrideWarranty')"
                    data-cy="overrideModelWarranty"
                    :error-messages="
                      form().serverErrors(this, 'overrideModelWarranty')
                    "
                    @change="fieldValueChanged('overrideModelWarranty')"
                  ></v-checkbox>
                </v-col>

                <v-col
                  v-if="
                    form().showMe(this, 'LifeTimeWarranty') &&
                      obj.overrideModelWarranty
                  "
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-checkbox
                    ref="lifeTimeWarranty"
                    v-model="obj.lifeTimeWarranty"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitOverrideLifeTime')"
                    data-cy="lifeTimeWarranty"
                    :error-messages="
                      form().serverErrors(this, 'lifeTimeWarranty')
                    "
                    @change="fieldValueChanged('lifeTimeWarranty')"
                  ></v-checkbox>
                </v-col>

                <v-col
                  v-if="
                    form().showMe(this, 'WarrantyLength') &&
                      obj.overrideModelWarranty &&
                      !obj.lifeTimeWarranty
                  "
                  cols="12"
                  sm="6"
                  lg="4"
                  xl="3"
                >
                  <v-text-field
                    ref="warrantyLength"
                    v-model="obj.warrantyLength"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitOverrideLength')"
                    data-cy="warrantyLength"
                    :rules="[form().integerValid(this, 'warrantyLength')]"
                    :error-messages="
                      form().serverErrors(this, 'warrantyLength')
                    "
                    type="number"
                    @input="fieldValueChanged('warrantyLength')"
                  ></v-text-field>
                </v-col>

                <v-col
                  v-if="
                    form().showMe(this, 'WarrantyTerms') &&
                      obj.overrideModelWarranty
                  "
                  cols="12"
                >
                  <v-textarea
                    ref="warrantyTerms"
                    v-model="obj.warrantyTerms"
                    dense
                    :readonly="formState.readOnly"
                    :label="$ay.t('UnitOverrideWarrantyTerms')"
                    :error-messages="form().serverErrors(this, 'warrantyTerms')"
                    data-cy="warrantyTerms"
                    auto-grow
                    @input="fieldValueChanged('warrantyTerms')"
                  ></v-textarea>
                </v-col>
              </v-row>
            </v-tab-item>
          </v-tabs-items>
        </v-tabs>
      </v-form>
    </div>
    <v-overlay :value="!formState.ready || formState.loading">
      <v-progress-circular indeterminate :size="64" />
    </v-overlay>
  </div>
</template>
<script>
const FORM_KEY = "unit-edit";
const API_BASE_URL = "unit/";
const FORM_CUSTOM_TEMPLATE_KEY = "Unit";
export default {
  data() {
    return {
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      obj: {
        id: 0,
        concurrency: 0,
        serial: null,
        active: true,
        notes: null,
        wiki: null,
        customFields: "{}",
        tags: [],
        customerId: null,
        parentUnitId: null,
        unitModelId: null,
        unitHasOwnAddress: false,
        boughtHere: false,
        purchasedFromVendorId: null,
        receipt: null,
        purchasedDate: null,
        description: null,
        replacedByUnitId: null,
        overrideModelWarranty: false,
        warrantyLength: null,
        warrantyTerms: null,
        //usesBanking: false,
        contractId: null,
        contractExpires: null,
        metered: false,
        lifeTimeWarranty: false,
        text1: null,
        text2: null,
        text3: null,
        text4: null,
        address: null,
        city: null,
        region: null,
        country: null,
        addressPostal: null,
        latitude: null,
        longitude: null
      },
      tab: 0,
      formState: {
        ready: false,
        dirty: false,
        valid: true,
        readOnly: false,
        loading: true,
        errorBoxMessage: null,
        appError: null,
        serverError: {}
      },
      rights: window.$gz.role.defaultRightsObject(),
      ayaType: window.$gz.type.Unit
    };
  },
  watch: {
    formState: {
      handler: function(val) {
        if (this.formState.loading) {
          return;
        }

        if (val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":save");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":save");
        }

        if (!val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit(
            "menu-enable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":new");
        } else {
          window.$gz.eventBus.$emit(
            "menu-disable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":new");
        }
      },
      deep: true
    }
  },
  async created() {
    const vm = this;
    try {
      await initForm(vm);
      vm.rights = window.$gz.role.getRights(window.$gz.type.Unit);
      vm.formState.readOnly = !vm.rights.change;
      window.$gz.eventBus.$on("menu-click", clickHandler);
      let setDirty = false;
      //id 0 means create or duplicate to new
      if (vm.$route.params.recordid != 0) {
        //is there already an obj from a prior operation?
        if (this.$route.params.obj) {
          //yes, no need to fetch it
          this.obj = this.$route.params.obj;
        } else {
          await vm.getDataFromApi(vm.$route.params.recordid);
        }
      } else {
        //Might be a duplicate and contain another record
        if (this.$route.params.obj) {
          this.obj = this.$route.params.obj;
          this.obj.concurrency = undefined;
          this.obj.id = 0;
          this.obj.serial = `${this.obj.serial} - ${window.$gz.translation.get(
            "Copy"
          )}`;
          setDirty = true;
        } else {
          //check for generate unit from part info on route params
          //(set by workorder item part when user selects generate unit from part)
          const gen = this.$route.params.genFromPart;
          if (gen) {
            //get the part then set the values accordingly
            const res = await window.$gz.api.get(`part/${gen.partId}`);
            if (res.error) {
              window.$gz.eventBus.$emit(
                "notify-warning",
                window.$gz.errorHandler.errorToString(res, this)
              );
            } else {
              const p = res.data;
              this.obj.boughtHere = true;
              this.obj.customerId = gen.customerId;
              this.obj.serial = gen.serial;
              this.obj.purchasedDate = gen.purchaseDate;
              this.obj.description = p.name;
              if (
                gen.address ||
                gen.city ||
                gen.region ||
                gen.country ||
                gen.addressPostal ||
                gen.latitude ||
                gen.longitude
              ) {
                this.obj.unitHasOwnAddress = true;
                this.obj.address = gen.address ?? null;
                this.obj.city = gen.city ?? null;
                this.obj.region = gen.region ?? null;
                this.obj.country = gen.country ?? null;
                this.obj.addressPostal = gen.addressPostal ?? null;
                this.obj.latitude = gen.latitude ?? null;
                this.obj.longitude = gen.longitude ?? null;
              }

              if (p.name) {
                this.obj.description += ` ${p.name}`;
              }
            }
            setDirty = true;
          }
        }
      }

      window.$gz.form.setFormState({
        vm: vm,
        loading: false,
        dirty: setDirty,
        valid: true
      });

      generateMenu(vm);
    } catch (error) {
      window.$gz.errorHandler.handleFormError(error, vm);
    } finally {
      vm.formState.ready = true;
    }
  },
  async beforeRouteLeave(to, from, next) {
    if (!this.formState.dirty || JUST_DELETED) {
      next();
      return;
    }
    if ((await window.$gz.dialog.confirmLeaveUnsaved()) === true) {
      next();
    } else {
      next(false);
    }
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    // canOpenServiceBank: function() {
    //   return this.obj.usesBanking == true && this.$route.params.recordid != 0;
    // },
    // openServiceBank: function() {
    //   if (this.canOpenServiceBank()) {
    //     this.$router.push({
    //       name: "service-banks",
    //       params: {
    //         aType: window.$gz.type.Unit,
    //         objectId: this.$route.params.recordid,
    //         viz: this.obj.serial,
    //         icon: "$ayiFan"
    //       }
    //     });
    //   }
    // },
    canOpenMeter: function() {
      return this.obj.metered == true && this.$route.params.recordid != 0;
    },
    openMeter: function() {
      if (this.canOpenMeter()) {
        this.$router.push({
          name: "meter-readings",
          params: { unitid: this.obj.id, unitname: this.obj.serial }
        });
      }
    },
    canSave: function() {
      return this.formState.valid && this.formState.dirty;
    },
    canDuplicate: function() {
      return this.formState.valid && !this.formState.dirty;
    },
    ayaTypes: function() {
      return window.$gz.type;
    },
    form() {
      return window.$gz.form;
    },
    fieldValueChanged(ref) {
      if (
        this.formState.ready &&
        !this.formState.loading &&
        !this.formState.readOnly
      ) {
        window.$gz.form.fieldValueChanged(this, ref);
      }
    },
    async getDataFromApi(recordId) {
      const vm = this;
      window.$gz.form.setFormState({
        vm: vm,
        loading: true
      });
      if (!recordId) {
        throw new Error(FORM_KEY + "::getDataFromApi -> Missing recordID!");
      }
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.get(API_BASE_URL + recordId);
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          vm.obj = res.data;
          generateMenu(vm);
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false
          });
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async submit() {
      const vm = this;
      if (vm.canSave == false) {
        return;
      }
      try {
        window.$gz.form.setFormState({
          vm: vm,
          loading: true
        });
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.upsert(API_BASE_URL, vm.obj);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data.id) {
            //POST
            vm.obj = res.data;
            this.$router.replace({
              name: "unit-edit",
              params: {
                recordid: res.data.id,
                obj: res.data
              }
            });
          } else {
            //PUT
            vm.obj.concurrency = res.data.concurrency;
          }
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async remove() {
      try {
        const dialogResult = await window.$gz.dialog.confirmDelete();
        if (dialogResult != true) {
          return;
        }
        window.$gz.form.setFormState({
          vm: this,
          loading: true
        });

        if (this.$route.params.recordid == 0) {
          JUST_DELETED = true;

          this.$router.go(-1);
        } else {
          window.$gz.form.deleteAllErrorBoxErrors(this);
          const res = await window.$gz.api.remove(
            API_BASE_URL + this.$route.params.recordid
          );
          if (res.error) {
            this.formState.serverError = res.error;
            window.$gz.form.setErrorBoxErrors(this);
          } else {
            JUST_DELETED = true;
            this.$router.go(-1);
          }
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, this);
      } finally {
        window.$gz.form.setFormState({
          vm: this,
          loading: false
        });
      }
    },
    duplicate() {
      this.$router.push({
        name: "unit-edit",
        params: {
          recordid: 0,
          obj: this.obj
        }
      });
    },

    AddressCopyPhysicalToClipBoard() {
      const vm = this;
      let ret = "";
      if (vm.obj.name) {
        ret += vm.obj.name + "\n";
      }
      if (vm.obj.address) {
        ret += vm.obj.address + "\n";
      }

      if (vm.obj.city) {
        ret += vm.obj.city + " ";
      }

      if (vm.obj.region) {
        ret += vm.obj.region + " ";
      }

      if (vm.obj.country) {
        ret += vm.obj.country + "\n";
      }
      if (vm.obj.addressPostal) {
        //Postal codes should have two spaces before them according to regs.
        ret += "  " + vm.obj.addressPostal + "\n";
      }

      window.$gz.util.copyToClipboard(ret);
    },
    async GeoCapture() {
      const vm = this;
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const loc = await window.$gz.util.getGeoLocation();
        vm.obj.latitude = loc.latitude;
        vm.fieldValueChanged("latitude");
        vm.obj.longitude = loc.longitude;
        vm.fieldValueChanged("longitude");
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      }
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "save":
        m.vm.submit();
        break;
      case "delete":
        m.vm.remove();
        break;
      case "new":
        m.vm.$router.push({
          name: "unit-edit",
          params: { recordid: 0 }
        });
        break;
      case "duplicate":
        m.vm.duplicate();
        break;
      case "report":
        {
          const res = await m.vm.$refs.reportSelector.open(
            {
              AType: window.$gz.type.Unit,
              selectedRowIds: [m.vm.obj.id]
            },
            m.id
          );
          if (res == null) {
            return;
          }
          window.$gz.form.setLastReportMenuItem(FORM_KEY, res, m.vm);
        }
        break;
      case "geoview":
        window.$gz.util.viewGeoLocation({
          latitude: m.vm.obj.latitude,
          longitude: m.vm.obj.longitude,
          address: m.vm.obj.address || m.vm.obj.postAddress,
          city: m.vm.obj.city || m.vm.obj.postCity,
          region: m.vm.obj.region || m.vm.obj.postRegion,
          country: m.vm.obj.country || m.vm.obj.postCountry,
          postCode: m.vm.obj.postCode,
          addressPostal: m.vm.obj.addressPostal
        });
        break;
      case "WorkOrderItemUnitList":
        m.vm.$router.push({
          name: "svc-workorder-item-units",
          params: {
            aType: m.vm.ayaType,
            objectId: m.vm.obj.id,
            name: m.vm.obj.serial
          }
        });
        break;
      case "QuoteList":
        m.vm.$router.push({
          name: "svc-quote-item-units",
          params: {
            aType: m.vm.ayaType,
            objectId: m.vm.obj.id,
            name: m.vm.obj.serial
          }
        });
        break;
      case "PMList":
        m.vm.$router.push({
          name: "svc-pm-item-units",
          params: {
            aType: m.vm.ayaType,
            objectId: m.vm.obj.id,
            name: m.vm.obj.serial
          }
        });
        break;
      case "newwo":
        m.vm.$router.push({
          name: "workorder-edit",
          params: {
            recordid: 0,
            customerId: m.vm.obj.customerId,
            add: {
              type: m.vm.$ay.ayt().WorkOrderItemUnit,
              unitId: m.vm.obj.id
            }
          }
        });
        break;

      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: false,
    readOnly: vm.formState.readOnly,
    icon: "$ayiFan",
    title: "Unit",
    helpUrl: "svc-units",
    formData: {
      ayaType: window.$gz.type.Unit,
      recordId: vm.$route.params.recordid,
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      recordName: vm.obj.serial
    },
    menuItems: []
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "Save",
      icon: "$ayiSave",
      surface: true,
      key: FORM_KEY + ":save",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Report",
    icon: "$ayiFileAlt",
    key: FORM_KEY + ":report",
    vm: vm
  });

  const lastReport = window.$gz.form.getLastReport(FORM_KEY);
  if (lastReport != null) {
    menuOptions.menuItems.push({
      title: lastReport.name,
      notrans: true,
      icon: "$ayiFileAlt",
      key: FORM_KEY + ":report:" + lastReport.id,
      vm: vm
    });
  }

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "New",
      icon: "$ayiPlus",
      key: FORM_KEY + ":new",
      vm: vm
    });
  }

  if (vm.rights.change && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Duplicate",
      icon: "$ayiClone",
      key: FORM_KEY + ":duplicate",
      vm: vm
    });
  }

  if (vm.rights.delete && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Delete",
      icon: "$ayiTrashAlt",
      surface: false,
      key: FORM_KEY + ":delete",
      vm: vm
    });
  }

  menuOptions.menuItems.push({ divider: true, inset: false });

  if (
    vm.$route.params.recordid != 0 &&
    vm.obj.customerId != 0 &&
    window.$gz.role.canChange(window.$gz.type.WorkOrder)
  ) {
    menuOptions.menuItems.push({
      title: "NewWorkOrder",
      icon: "$ayiTools",
      key: FORM_KEY + ":newwo",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "UnitModels",
    icon: "$ayiDiceD20",
    data: "svc-unit-models",
    key: "app:nav"
  });

  menuOptions.menuItems.push({
    title: "WorkOrderList", //note: technically it opens teh woitemunitlist not workorders but it's confusing in the UI otherwise and this is how people would think about it
    icon: "$ayiTools",
    key: FORM_KEY + ":WorkOrderItemUnitList",
    vm: vm
  });

  menuOptions.menuItems.push({
    title: "QuoteList",
    icon: "$ayiPencilAlt",
    key: FORM_KEY + ":QuoteList",
    vm: vm
  });

  menuOptions.menuItems.push({
    title: "PMList",
    icon: "$ayiBusinessTime",
    key: FORM_KEY + ":PMList",
    vm: vm
  });

  menuOptions.menuItems.push({
    title: "GeoView",
    icon: "$ayiMapMarked",
    key: FORM_KEY + ":geoview",
    vm: vm
  });

  menuOptions.menuItems.push({ divider: true, inset: false });

  window.$gz.eventBus.$emit("menu-change", menuOptions);
}

let JUST_DELETED = false;

/////////////////////////////////
//
//
async function initForm(vm) {
  await fetchTranslatedText();
  await window.$gz.formCustomTemplate.get(FORM_CUSTOM_TEMPLATE_KEY, vm);
}

//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations([
    "Unit",
    "UnitSerial",
    "UnitNotes",
    "Customer",
    "UnitParentUnitID",
    "UnitModel",
    "UnitUnitHasOwnAddress",
    "UnitBoughtHere",
    "UnitPurchaseFromID",
    "UnitReceipt",
    "UnitPurchasedDate",
    "UnitDescription",
    "UnitReplacedByUnitID",
    "UnitOverrideWarranty",
    "UnitOverrideLength",
    "UnitOverrideWarrantyTerms",
    "Contract",
    "ContractExpires",
    "UnitMetered",
    "UnitOverrideLifeTime",
    "UnitText1",
    "UnitText2",
    "UnitText3",
    "UnitText4",
    "AddressTypePhysical",
    "Address",
    "AddressDeliveryAddress",
    "AddressCity",
    "AddressStateProv",
    "AddressCountry",
    "AddressPostal",
    "AddressLatitude",
    "AddressLongitude",
    "UnitCustom1",
    "UnitCustom2",
    "UnitCustom3",
    "UnitCustom4",
    "UnitCustom5",
    "UnitCustom6",
    "UnitCustom7",
    "UnitCustom8",
    "UnitCustom9",
    "UnitCustom10",
    "UnitCustom11",
    "UnitCustom12",
    "UnitCustom13",
    "UnitCustom14",
    "UnitCustom15",
    "UnitCustom16",
    "UnitMeterReadingList",
    "NewWorkOrder"
  ]);
}
</script>
